/* list.c   list operators
     based on LISP-like function

	 for project som-c	 27 Dec 2003
	 reimplement without struct  15 Jan 2004
*/

#include "compile.h"

#define   CELLPTR 		10    // min pointer to acell

PRIVATE int *cell = &M[0];
PRIVATE int freecell = MAXCS;

int car(int a){ return cell[a]; }
int cdr(int a){ return cell[a+1]; }
void setcar(int a, int value){ cell[a] = value; }
void setcdr(int a, int value){ cell[a+1] = value; }

PRIVATE int newcell(void){
	int a;
	a = freecell;
	if( a == NIL ) seterror("out of memory cells");
	freecell = cdr(a);
	setcdr(a, NIL);
	return a;
}

int countcell(void){
	int a, k;
	k = 0;
	a = freecell;
	while ( a != NIL ){
		k++;
		a = cdr(a);
	}
	return k;
}

int islist(int x){ return car(x) >= CELLPTR; }
int isatom(int x){ return car(x) < CELLPTR; }

int newatom(int type, int value){
	int a;
	a = newcell();
	setcar(a,type);
	setcdr(a,value);
	return a;
}

void initcell(void){
	int i;
	for(i=MAXMEM-2; i>=MAXCS; i-=2){
		setcar(i,0);
		setcdr(i,i+2);
	}
	setcdr(MAXMEM-2,NIL);
	freecell = MAXCS;
}

int list(int a){
	int b;
	b = newcell();
	setcar(b,a);
	return b;
}

int cons(int a, int l){
	int b;
	b = newcell();
	setcdr(b,l);
	setcar(b,a);
	return b;
}

int append(int l, int x){
	int a, b;
	if( x == NIL ) return l;
	a = l;
	while( (b = cdr(a)) != NIL )
		a = b;
	setcdr(a,list(x));
	return l;
}

void prlist(int a){
	if( a == NIL ) return;
	if( isatom(a) ){
		switch(car(a)){
		case SP: printf("NIL "); break;
		case OPER: prtok(cdr(a)); break;
		case ADS:
		case NUM: printf("%d ",cdr(a)); break;
		case GNAME: printf("%s ",getName(cdr(a))); break;
		case LNAME: printf("#%d ",cdr(a)); break;
		case STRING: prstr(cdr(a)); break;
		}
	}else{
		printf("(");
		while( a != NIL ){
			prlist(car(a));
			a = cdr(a);
		}
		printf(")");
	}
}

/*
void testlist(){
	int a, b, c, d, e, f;
	initcell();
	a = newatom(1,10);
	b = newatom(1,20);
	c = list(b);
	d = cons(a,c);
	d = list(d);
	e = newatom(1,30);
	f = cons(e,d);
	f = append(d,e);
	prlist(f);
	prlist(car(f));
	prlist(cdr(f));
	prlist(car(cdr(f)));
	prlist(cdr(cdr(f)));
}
*/
